%define sumo    2005-12-08
%define pkgdir  %{_datadir}/xemacs
%define xemacsb xemacs-nox -batch -vanilla

Name:           xemacs-sumo
Version:        %(echo %{sumo} | tr -d -)
Release:        2
Summary:        XEmacs lisp packages

Group:          Applications/Editors
License:        GPL
URL:            http://www.xemacs.org/Documentation/packageGuide.html#The_Sumo_Tarball
Source0:        ftp://ftp.xemacs.org/packages/xemacs-sumo-%{sumo}.tar.bz2
Source1:        ftp://ftp.xemacs.org/packages/xemacs-mule-sumo-%{sumo}.tar.bz2
Source2:        ftp://ftp.xemacs.org/packages/gnus-1.89-pkg.tar.gz
Source10:       Emacs.ad.ja_JP.eucJP
Source11:       Emacs.ad.ko_KR.eucKR
Source12:       Emacs.ad.zh_CN.GB2312
Source13:       Emacs.ad.zh_TW.Big5
Source14:       Emacs.ad.ja_JP.UTF-8
Source15:       Emacs.ad.ko_KR.UTF-8
Source16:       Emacs.ad.zh_CN.UTF-8
Source17:       Emacs.ad.zh_TW.UTF-8
Patch0:         %{name}-20051208-hypb-posix.patch
Patch1:         %{name}-20051208-pydoc-path.patch
Patch2:         %{name}-20051208-latin-unity-kludge.patch
Patch3:         %{name}-20051208-trax.patch
Patch6:         auctex-texsite-jlatex-detect-69129.patch
Patch7:         auctex-texjp-platex.patch
Patch8:         egg-wnn-host-unix-79826.patch
Patch11:        browse-url-htmlview-84262.patch
Patch12:        psgml-browsers-84262.patch
Patch15:        avoid-catch-error-65346.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildArch:      noarch
BuildRequires:  xemacs-nox
BuildRequires:  sed >= 3.95
BuildRequires:  /sbin/install-info
BuildRequires:  %{__python}
BuildRequires:  %{__perl}
BuildRequires:  java-devel
Requires:       xemacs-common
# Fake release in this provision in order to avoid self-obsoletion (for now).
Provides:       apel-xemacs = 10.6-6
Provides:       ruby-mode-xemacs
Obsoletes:      apel-xemacs < 10.6-6
Obsoletes:      ruby-mode-xemacs
Obsoletes:      tm
Conflicts:      xemacs < 21.4.12-12

%description
XEmacs is a highly customizable open source text editor and
application development system.  It is protected under the GNU General
Public License and related to other versions of Emacs, in particular
GNU Emacs.  Its emphasis is on modern graphical user interface support
and an open software development model, similar to Linux.

The XEmacs Sumo packages contain a large collection of useful lisp
packages for XEmacs including mailreaders, programming modes and
utilities, and packages related to using XEmacs in multi-lingual
environments.

%package        el
Summary:        Emacs lisp source files for the XEmacs Sumo packages
Group:          Development/Libraries
Requires:       xemacs-sumo = %{version}
Conflicts:      xemacs-el < 21.4.12-12

%description    el
This package is not needed to run XEmacs; it contains the lisp source
files for the XEmacs Sumo packages, mainly of interest when developing
or debugging the packages.

%package        info
Summary:        XEmacs packages documentation in GNU texinfo format
Group:          Documentation
Conflicts:      xemacs-info < 21.4.12-12

%description    info
This package contains optional documentation for the XEmacs Sumo
packages in GNU texinfo format


%prep
%setup -q -c -a1
tar zxf %{SOURCE2} -C xemacs-packages

# get rid of csh dependency
%patch0 -p0
rm xemacs-packages/lisp/hyperbole/file-newer
# find pydoc_lisp.py out-of-the-box
%patch1 -p0
install -dm 755 xemacs-packages/etc/python-modes
mv xemacs-packages/{lisp/python-modes/pydoc_lisp.py,etc/python-modes}
# support write-region's kludge in latin-unity
%patch2 -p0
# use TrAX by default in xslt-process
%patch3 -p0
# fix jlatex autodetection
%patch6 -p0
# use ptex rather jtex by default for Japanese
%patch7 -p1
# make egg-wnn use unix domain socket by default
%patch8 -p0
# default to htmlview as generic browse-url browser
%patch11 -p0
# update psgml-html preview menu to modern browsers
%patch12 -p0
# catch harmless errors in mouse-avoidance-too-close-p (avoid.el)
%patch15 -p0

sed -i -e "s|/usr/local/bin/perl5\\?|/usr/bin/perl|g" \
  xemacs-packages/etc/bbdb/*.pl

chmod -c -x xemacs-packages/lisp/edit-utils/crm.el

# remove game we shouldn't ship
rm xemacs-packages/lisp/games/tetris.el*

rm xemacs-packages/etc/xslt-process/java/{xslt.jar,xslt/*.class}

# not buildable from sources, all deps not met, see 2006-03-03 changelog entry
%{xemacsb} -l package-admin -eval \
  "(package-admin-delete-binary-package 'jde \"xemacs-packages\")"
rm -rf xemacs-packages/{etc,lisp}/jde

# provided by mew-xemacs
%{xemacsb} -l package-admin -eval \
  "(package-admin-delete-binary-package 'mew \"xemacs-packages\")"
rmdir xemacs-packages/{etc,lisp,man}/mew

# provided by ddskk-xemacs
%{xemacsb} -l package-admin -eval \
  "(package-admin-delete-binary-package 'skk \"mule-packages\")"
rmdir mule-packages/{etc,lisp,man}/skk


%build
export EMACSPACKAGEPATH=`pwd`
%{xemacsb} -no-autoloads -eval "(setq make-backup-files nil)" \
  -f batch-update-directory xemacs-packages/lisp/* mule-packages/lisp/*
%{xemacsb} -f batch-byte-recompile-directory \
  xemacs-packages/lisp mule-packages/lisp

cd xemacs-packages/etc/xslt-process/java
javac xslt/TrAX.java && jar cvf xslt.jar xslt/*.class && rm xslt/*.class
cd -


%install
rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{pkgdir}
cp -rp xemacs-packages mule-packages $RPM_BUILD_ROOT%{pkgdir}

cd $RPM_BUILD_ROOT%{pkgdir}/mule-packages/etc/app-defaults
mkdir {de_DE,fr_FR,ro_RO,ja_JP,ko_KR,zh_CN,zh_TW}.UTF-8 \
  ja_JP.eucJP ko_KR.eucKR zh_CN.GB2312 zh_TW.Big5
iconv -f ISO-8859-1  -t UTF-8 de/Emacs > de_DE.UTF-8/Emacs
iconv -f ISO-8859-1  -t UTF-8 fr/Emacs > fr_FR.UTF-8/Emacs
iconv -f ISO-8859-16 -t UTF-8 ro/Emacs > ro_RO.UTF-8/Emacs
mv de de_DE
mv fr fr_FR
mv ro ro_RO
install -pm 644 %{SOURCE10} ja_JP.eucJP/Emacs
install -pm 644 %{SOURCE11} ko_KR.eucKR/Emacs
install -pm 644 %{SOURCE12} zh_CN.GB2312/Emacs
install -pm 644 %{SOURCE13} zh_TW.Big5/Emacs
install -pm 644 %{SOURCE14} ja_JP.UTF-8/Emacs
install -pm 644 %{SOURCE15} ko_KR.UTF-8/Emacs
install -pm 644 %{SOURCE16} zh_CN.UTF-8/Emacs
install -pm 644 %{SOURCE17} zh_TW.UTF-8/Emacs
# these don't seem to appear in manifest
#ln -s ja_JP.eucJP ja_JP
#ln -s ko_KR.eucKR ko_KR
#ln -s zh_CN.GB2312 zh_CN
#ln -s zh_TW.Big5 zh_TW
cd -

# info docs: pre-generate "dir"s and compress files
for file in $RPM_BUILD_ROOT%{pkgdir}/*-packages/info/*.info ; do
  /sbin/install-info $file `dirname $file`/dir
done
find $RPM_BUILD_ROOT%{pkgdir} -type f -name '*.info*' | xargs gzip -9

# separate files
rm -f *.files
echo "%%defattr(-,root,root,-)" > base-files
echo "%%defattr(-,root,root,-)" > el-files
echo "%%defattr(-,root,root,-)" > info-files

find $RPM_BUILD_ROOT%{pkgdir}/* \
  \( -type f -name '*.el.orig' -exec rm '{}' ';' \) -o \
  \( -type f -not -name '*.el' -fprint base-non-el.files \) -o \
  \( -type d -not -name info -fprintf dir.files "%%%%dir %%p\n" \) -o \
  \( -name '*.el' \( -exec test -e '{}'c \; -fprint el-bytecomped.files -o \
     -fprint base-el-not-bytecomped.files \) \)

sed -i -e "s|$RPM_BUILD_ROOT||" *.files
cat base-*.files dir.files | grep -v /info/ >> base-files
cat el-*.files dir.files                    >> el-files
cat base-non-el.files | grep /info/         >> info-files

sed -i -e 's/^\(.*\(\.ja\|-ja\.texi\)\)$/%lang(ja) \1/' base-files
sed -i -e 's/^\(.*[_-]ja\.info.*\)$/%lang(ja) \1/' info-files

# in case redhat-rpm-config is not installed or doesn't do this for us:
%{__python} -c "import compileall; compileall.compile_dir('$RPM_BUILD_ROOT%{pkgdir}/xemacs-packages/etc/python-modes', ddir='/', force=1)"
%{__python} -O -c "import compileall; compileall.compile_dir('$RPM_BUILD_ROOT%{pkgdir}/xemacs-packages/etc/python-modes', ddir='/', force=1)"


%clean
rm -rf $RPM_BUILD_ROOT


%files -f base-files
%{pkgdir}/xemacs-packages/etc/python-modes/*.pyc
%ghost %{pkgdir}/xemacs-packages/etc/python-modes/*.pyo

%files el -f el-files

%files info -f info-files
%dir %{pkgdir}/*-packages/info/


%changelog
* Fri Mar  3 2006 Ville Skyttä <ville.skytta at iki.fi> - 20051208-2
- Drop JDE; the full source for jde.jar doesn't seem to be available
  and even the included parts won't build with gcj eg. due to use of
  com.sun.* things.  Additionally it requires third party jars which are
  not currently available in Fedora Core or Extras.  So let's not inflict
  a crippled version of JDE on anyone; JDE users can install the upstream
  jde package using XEmacs package tools. (#180941)

* Sun Feb 12 2006 Ville Skyttä <ville.skytta at iki.fi>
- Build xslt.jar ourselves (TrAX only), use TrAX by default in xslt-process.

* Sat Feb 11 2006 Ville Skyttä <ville.skytta at iki.fi>
- Bundle upstream gnus package version 1.89 to fix #181011.
- Get rid of tli_rbl binary only applet jar in jde's docs (first step
  of fixing #180941).

* Sat Dec 17 2005 Ville Skyttä <ville.skytta at iki.fi> - 20051208-1
- Patch to support write-region's kludge in latin-unity.

* Fri Dec  9 2005 Ville Skyttä <ville.skytta at iki.fi>
- 2005-12-08.
- Patch hyperbole to not require csh.
- Patch pydoc.el to find pydoc_lisp.py out of the box.
- Include bytecompiled python files.
- Set %%lang for various docs and info files.
- Prune changelog entries from pre-xemacs-sumo times.

* Sat Jul 16 2005 Ville Skyttä <ville.skytta at iki.fi> - 20050715-1
- 2005-07-15; jde font-lock, sql-mode abbrev, w3 stylesheet and file
  permissions fixed upstream.
- Use sed instead of perl for in-place edits during build.

* Wed Jul 13 2005 Ville Skyttä <ville.skytta at iki.fi> - 20050505-7
- Remove mew and skk, they're in separate packages again (#162952).
- Reformat specfile.

* Thu Jun  2 2005 Ville Skyttä <ville.skytta at iki.fi> - 20050505-6
- Make sure we're using files included in this package
  when byte-recompiling patched *.el; also allows the byte-compilation
  to actually happen even if no previous xemacs-sumo is installed.

* Wed Jun  1 2005 Ville Skyttä <ville.skytta at iki.fi> - 20050505-5
- Bundle upstream cc-mode package version 1.45 (contains cc-mode 5.30.10).
- Fix JDEE font-lock warnings with import statements.

* Tue May 24 2005 Ville Skyttä <ville.skytta at iki.fi> - 20050505-3
- Apply improved upstream patch against JDE font-lock warnings.

* Fri May 20 2005 Ville Skyttä <ville.skytta at iki.fi> - 20050505-2
- Apply upstream patch to fix abbrev error when loading sql-mode.

* Thu May  5 2005 Ville Skyttä <ville.skytta at iki.fi> - 20050505-1
- 2005-05-05, mh-e toolbar specifier fix applied upstream.
- Apply patch from Aidan Kehoe to fix font-lock warnings in JDE.

* Wed Apr  6 2005 Ville Skyttä <ville.skytta at iki.fi> - 20050307-2
- Make scripts in lib-src/ executable (Emmanuel Thomé, #134512).
- Drop no longer needed workaround for #64320.

* Tue Mar  8 2005 Ville Skyttä <ville.skytta at iki.fi> - 20050307-1
- Update to 2005-03-07.
- Fix up unneeded executable bits on some files.

* Tue Mar  1 2005 Ville Skyttä <scop@xemacs.org> - 20050118-2
- Revert back to bundled apel, mew and skk in the sumo.
- Drop xemacs-packages* Obsoletes.
- Build with xemacs-nox to fix chicken-egg bootstrap problem.
- Require xemacs-common.
- Remove pre-XEmacs-21.4 %%changelog entries.

* Wed Jan 19 2005 Jens Petersen <petersen@redhat.com> 20050118-1
- update to new sumos
  - update auctex-texjp-platex.patch
  - auctex-texsite-lisp-dir.patch no longer needed
  - auc-tex.info is now correctly auctex.info
- physically remove .el.orig patch backup files

* Tue Dec 14 2004 Jens Petersen <petersen@redhat.com>
- add auctex-texsite-lisp-dir.patch to initialise auctex TeX-lisp-directory
- exclude .orig backup files

* Wed Oct  6 2004 Jens Petersen <petersen@redhat.com> - 20040818-2
- rename auc-tex.info to auctex.info (Francis Tang, 134624)

* Wed Aug 18 2004 Jens Petersen <petersen@redhat.com> 20040818-1
- update to 2004-08-18 sumos
  - no longer need to replace xlib and xwem packages
  - cvs.el-history-log.patch is now upstream

* Mon Aug 16 2004 Ville Skyttä <scop@xemacs.org> - 20040517-4
- replace xlib-autoload-startup-msg-125415.patch with xlib and xwem pre-release
  pkgs to really make them quiet at startup (125415,130019)
- pre-generate package info dir files and compress all the info files (130019)

* Mon Aug  9 2004 Jens Petersen <petersen@redhat.com> - 20040517-3
- default cvs-no-log-option to nil since cvs no longer accepts "-l" option
  with cvs.el-history-log.patch
- silence startup messages from xlib and xwem (125415) with
  xlib-autoload-startup-msg-125415.patch

* Tue Jun 15 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Thu May 20 2004 Jens Petersen <petersen@redhat.com> 20040517-1
- update to 2004-05-17 release

* Fri May  7 2004 Jens Petersen <petersen@redhat.com> - 20040202-4
- do not require xemacs, so that it is installable with xemacs-nox

* Thu Apr  1 2004 Jens Petersen <petersen@redhat.com> - 20040202-3
- remove executable flags from erc Changelog files [Ville Skyttä]

* Fri Feb 13 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Wed Feb  4 2004 Jens Petersen <petersen@redhat.com> - 20040202-1
- update to 2004-02-02 sumos
- update browse-url-htmlview-84262.patch
- subtract 100 from all patch numbers

* Tue Nov 18 2003 Jens Petersen <petersen@redhat.com> - 20031113-1
- update to 2003-11-13 release

* Sat Oct 18 2003 Jens Petersen <petersen@redhat.com> - 20031003-3
- fix mh-e toolbar error (#100764) [reported by vonbrand@inf.utfsm.cl,
  fix by Stephen J. Turnbull]

* Fri Oct 17 2003 Jens Petersen <petersen@redhat.com> - 20031003-2
- generate X resource files in utf-8 for de, fr and ro (#107310) [frh@gmx.de]
- move our CJK X resource files here from xemacs with one file for
  native encoding and one for utf-8
- re-enable menubar translations for native CJK encodings (part of #106994)
  [Yukihiro Nakai]

* Mon Oct  6 2003 Jens Petersen <petersen@redhat.com> - 20031003-1
- update to 2003-10-03 release

* Mon Sep  1 2003 Jens Petersen <petersen@redhat.com> - 20030831-1
- update to 2003-08-31 release
- simplify /usr/local/bin/perl cleaning

* Tue Jul  1 2003 Jens Petersen <petersen@redhat.com> - 20030629-1
- update to 2003-06-29 release
- catch harmless mouse-avoidance-mode errors (#65346)
  [suggested by Reuben Thomas]

* Mon May 12 2003 Jens Petersen <petersen@redhat.com> - 20030414-1
- new package to separate xemacs-sumo and xemacs-mule-sumo from
  main xemacs package
